DevExtreme v26.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Html Editor - Tables

DevExtreme HTML Editor allows users to create and manage tables. This demo illustrates table resize support and table management with the toolbar, context menu, and in code.

Backend API
$(() => { const editor = $('#html-editor').dxHtmlEditor({ value: markup, height: 750, tableContextMenu: { enabled: true }, tableResizing: { enabled: true }, toolbar: { items: [ 'bold', 'color', 'separator', 'alignLeft', 'alignCenter', 'alignRight', 'separator', 'insertTable', 'insertHeaderRow', 'insertRowAbove', 'insertRowBelow', 'separator', 'insertColumnLeft', 'insertColumnRight', 'separator', 'deleteColumn', 'deleteRow', 'deleteTable', 'separator', 'cellProperties', 'tableProperties', ], }, }).dxHtmlEditor('instance'); $('#resizing').dxCheckBox({ text: 'Allow Table Resizing', value: true, onValueChanged(e) { editor.option('tableResizing.enabled', e.value); }, }); $('#contextMenu').dxCheckBox({ text: 'Enable Table Context Menu', value: true, onValueChanged(e) { editor.option('tableContextMenu.enabled', e.value); }, }); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" /> <script src="https://cdn.jsdelivr.net/npm/devextreme-quill@1.7.10/dist/dx-quill.min.js"></script> <script src="js/dx.all.js?v=26.1.3"></script> <script src="data.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="html-editor"></div> <div class="options"> <div class="caption">Options</div> <div class="option"> <div id="resizing"></div> </div> <div class="option"> <div id="contextMenu"></div> </div> </div> </div> </body> </html>
.demo-container { height: 950px; } .options { padding: 20px; background-color: rgba(191, 191, 191, 0.15); margin-top: 20px; } .caption { font-size: 18px; font-weight: 500; } .option { margin-top: 10px; }
const markup = ` <h2> Hardware Upgrade </h2> <br> <table> <thead> <tr> <th style="text-align: left; width: 320px;">Task Subject</th> <th style="text-align: center;">Status</th> <th style="text-align: right;">Progress</th> </tr> </thead> <tbody> <tr style="text-align: center;"> <td style="text-align: left; width: 320px;">Approve Personal Computer Upgrade Plan</td> <td style="text-align: center; color: #5cb85c;"> <p style="font-size: 1.15em;">✓</p> <p>Completed</p> </td> <td style="text-align: right;">100%</td> </tr> <tr style="text-align: center;"> <td style="text-align: left; width: 320px;">Prepare workspaces</td> <td style="text-align: center; color: #5cb85c;"> <p style="font-size: 1.15em;">✓</p> <p>Completed</p> </td> <td style="text-align: right;">100%</td> </tr> <tr style="text-align: center;"> <td style="text-align: left; width: 320px;">Upgrade Server Hardware</td> <td style="text-align: center;"> <p style="font-size: 1.15em;">⟳</p> <p>In Progress</p> </td> <td style="text-align: right;">45%</td> </tr> <tr style="text-align: center;"> <td style="text-align: left; width: 320px;">Upgrade Personal Computers</td> <td style="text-align: center; color: #f0ad4e;"> <p style="font-size: 1.15em;">‖</p> <p>Need Assistance</p> </td> <td style="text-align: right;">80%</td> </tr> <tr style="text-align: center;"> <td style="text-align: left; width: 320px;">Replace HDD with SSD</td> <td style="text-align: center;"> <p style="font-size: 1.15em;">⟳</p> <p>In Progress</p> </td> <td style="text-align: right;">80%</td> </tr> <tr style="text-align: center;"> <td style="text-align: left; width: 320px;">Purchase a New Server</td> <td style="text-align: center; color: #d9534f;"> <p style="font-size: 1.15em;">✖</p> <p>Canceled</p> </td> <td style="text-align: right;">15%</td> </tr> <tr style="text-align: center;"> <td style="text-align: left; width: 320px;">Purchase Laptops</td> <td style="text-align: center; color: #5cb85c;"> <p style="font-size: 1.15em;">✓</p> <p>Completed</p> </td> <td style="text-align: right;">100%</td> </tr> <tr style="text-align: center;"> <td style="text-align: left; width: 320px;">Prepare a list of necessary devices for testing</td> <td style="text-align: center; color: #5cb85c;"> <p style="font-size: 1.15em;">✓</p> <p>Completed</p> </td> <td style="text-align: right;">100%</td> </tr> <tr style="text-align: center;"> <td style="text-align: left; width: 320px;">Purchase devices for testing</td> <td style="text-align: center; color: #f0ad4e;"> <p style="font-size: 1.15em;">‖</p> <p>Need Assistance</p> </td> <td style="text-align: right;">25%</td> </tr> <tr style="text-align: center;"> <td style="text-align: left; width: 320px;">Recycle Broken Hardware</td> <td style="text-align: center; color: #5cb85c;"> <p style="font-size: 1.15em;">✓</p> <p>Completed</p> </td> <td style="text-align: right;">100%</td> </tr> </tbody> </table> <br> `;

Manage Tables with the Built-in Toolbar

To manage tables via a built-in toolbar, add the following items to it:

  • "insertTable" / "deleteTable"
    Manage a table.

  • "insertRowAbove" / "insertRowBelow" / "deleteRow"
    Manage rows.

  • "insertColumnLeft" / "insertColumnRight" / "deleteColumn"
    Manage columns.

  • "tableProperties" / "cellProperties"
    Open a pop-up window with table or cell customization options.

Manage Tables with the Context Menu

To manage table layouts with the context menu, set the tableContextMenu.enabled property to true. In this demo, you can click the Enable Table Context Menu check box under the JavaScript HtmlEditor to enable or disable this property. When it is enabled, right-click a table cell to open the context menu.

The context menu cannot be used to create new tables. The menu is only available within table boundaries. If you want users to create tables, add an "insertTable" item to the toolbar.

If you need to customize menu commands, override the tableContextMenu.items array. Refer to its description for a code example.

Manage Tables Programmatically

You can perform table-related actions in code. Use the getModule method to access the Table module. This module contains methods with names that match toolbar item names listed above. Refer to the following topic for the complete method list and code examples: DevExtreme Quill modules: Table.

Resize Tables

If you want to resize table rows and columns, set the tableResizing.enabled property to true. In this demo, you can use the Allow Table Resizing check box to change the property value.

You can also set the tableResizing.minColumnWidth and tableResizing.minRowHeight properties to specify minimum column width and row height. If you do not set these properties, width and height are determined by cell content. This demo illustrates the latter behavior (when you reduce column width or row height to small values).

import React, { useCallback, useState } from 'react';
import HtmlEditor, {
TableContextMenu,
TableResizing,
Toolbar,
Item,
} from 'devextreme-react/html-editor';
import { CheckBox, type CheckBoxTypes } from 'devextreme-react/check-box';
import { markup } from './data.ts';
export default function App() {
const [allowResizing, setAllowResizing] = useState(true);
const [contextMenuEnabled, setContextMenuEnabled] = useState(true);
const tableResizingChanged = useCallback((e: CheckBoxTypes.ValueChangedEvent) => {
setAllowResizing(e.value);
}, [setAllowResizing]);
const tableContextMenuChanged = useCallback((e: CheckBoxTypes.ValueChangedEvent) => {
setContextMenuEnabled(e.value);
}, [setContextMenuEnabled]);
return (
<div className="widget-container">
<HtmlEditor height="750px" defaultValue={markup}>
<TableContextMenu enabled={contextMenuEnabled} />
<TableResizing enabled={allowResizing} />
<Toolbar>
<Item name="bold" />
<Item name="color" />
<Item name="separator" />
<Item name="alignLeft" />
<Item name="alignCenter" />
<Item name="alignRight" />
<Item name="separator" />
<Item name="insertTable" />
<Item name="insertHeaderRow" />
<Item name="insertRowAbove" />
<Item name="insertRowBelow" />
<Item name="separator" />
<Item name="insertColumnLeft" />
<Item name="insertColumnRight" />
<Item name="separator" />
<Item name="deleteColumn" />
<Item name="deleteRow" />
<Item name="deleteTable" />
<Item name="separator" />
<Item name="cellProperties" />
<Item name="tableProperties" />
</Toolbar>
</HtmlEditor>
<div className="options">
<div className="caption">Options</div>
<div className="option">
<CheckBox
text="Allow Table Resizing"
value={allowResizing}
onValueChanged={tableResizingChanged}
/>
</div>
<div className="option">
<CheckBox
text="Enable Table Context Menu"
value={contextMenuEnabled}
onValueChanged={tableContextMenuChanged}
/>
</div>
</div>
</div>
);
}
import React, { useCallback, useState } from 'react';
import HtmlEditor, {
TableContextMenu,
TableResizing,
Toolbar,
Item,
} from 'devextreme-react/html-editor';
import { CheckBox } from 'devextreme-react/check-box';
import { markup } from './data.js';
export default function App() {
const [allowResizing, setAllowResizing] = useState(true);
const [contextMenuEnabled, setContextMenuEnabled] = useState(true);
const tableResizingChanged = useCallback(
(e) => {
setAllowResizing(e.value);
},
[setAllowResizing],
);
const tableContextMenuChanged = useCallback(
(e) => {
setContextMenuEnabled(e.value);
},
[setContextMenuEnabled],
);
return (
<div className="widget-container">
<HtmlEditor
height="750px"
defaultValue={markup}
>
<TableContextMenu enabled={contextMenuEnabled} />
<TableResizing enabled={allowResizing} />
<Toolbar>
<Item name="bold" />
<Item name="color" />
<Item name="separator" />
<Item name="alignLeft" />
<Item name="alignCenter" />
<Item name="alignRight" />
<Item name="separator" />
<Item name="insertTable" />
<Item name="insertHeaderRow" />
<Item name="insertRowAbove" />
<Item name="insertRowBelow" />
<Item name="separator" />
<Item name="insertColumnLeft" />
<Item name="insertColumnRight" />
<Item name="separator" />
<Item name="deleteColumn" />
<Item name="deleteRow" />
<Item name="deleteTable" />
<Item name="separator" />
<Item name="cellProperties" />
<Item name="tableProperties" />
</Toolbar>
</HtmlEditor>
<div className="options">
<div className="caption">Options</div>
<div className="option">
<CheckBox
text="Allow Table Resizing"
value={allowResizing}
onValueChanged={tableResizingChanged}
/>
</div>
<div className="option">
<CheckBox
text="Enable Table Context Menu"
value={contextMenuEnabled}
onValueChanged={tableContextMenuChanged}
/>
</div>
</div>
</div>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
export const markup = `
<h2>
Hardware Upgrade
</h2>
<br>
<table>
<thead>
<tr>
<th style="text-align: left; width: 320px;">Task Subject</th>
<th style="text-align: center;">Status</th>
<th style="text-align: right;">Progress</th>
</tr>
</thead>
<tbody>
<tr style="text-align: center;">
<td style="text-align: left; width: 320px;">Approve Personal Computer Upgrade Plan</td>
<td style="text-align: center; color: #5cb85c;">
<p style="font-size: 1.15em;">✓</p>
<p>Completed</p>
</td>
<td style="text-align: right;">100%</td>
</tr>
<tr style="text-align: center;">
<td style="text-align: left; width: 320px;">Prepare workspaces</td>
<td style="text-align: center; color: #5cb85c;">
<p style="font-size: 1.15em;">✓</p>
<p>Completed</p>
</td>
<td style="text-align: right;">100%</td>
</tr>
<tr style="text-align: center;">
<td style="text-align: left; width: 320px;">Upgrade Server Hardware</td>
<td style="text-align: center;">
<p style="font-size: 1.15em;">⟳</p>
<p>In Progress</p>
</td>
<td style="text-align: right;">45%</td>
</tr>
<tr style="text-align: center;">
<td style="text-align: left; width: 320px;">Upgrade Personal Computers</td>
<td style="text-align: center; color: #f0ad4e;">
<p style="font-size: 1.15em;">‖</p>
<p>Need Assistance</p>
</td>
<td style="text-align: right;">80%</td>
</tr>
<tr style="text-align: center;">
<td style="text-align: left; width: 320px;">Replace HDD with SSD</td>
<td style="text-align: center;">
<p style="font-size: 1.15em;">⟳</p>
<p>In Progress</p>
</td>
<td style="text-align: right;">80%</td>
</tr>
<tr style="text-align: center;">
<td style="text-align: left; width: 320px;">Purchase a New Server</td>
<td style="text-align: center; color: #d9534f;">
<p style="font-size: 1.15em;">✖</p>
<p>Canceled</p>
</td>
<td style="text-align: right;">15%</td>
</tr>
<tr style="text-align: center;">
<td style="text-align: left; width: 320px;">Purchase Laptops</td>
<td style="text-align: center; color: #5cb85c;">
<p style="font-size: 1.15em;">✓</p>
<p>Completed</p>
</td>
<td style="text-align: right;">100%</td>
</tr>
<tr style="text-align: center;">
<td style="text-align: left; width: 320px;">Prepare a list of necessary devices for testing</td>
<td style="text-align: center; color: #5cb85c;">
<p style="font-size: 1.15em;">✓</p>
<p>Completed</p>
</td>
<td style="text-align: right;">100%</td>
</tr>
<tr style="text-align: center;">
<td style="text-align: left; width: 320px;">Purchase devices for testing</td>
<td style="text-align: center; color: #f0ad4e;">
<p style="font-size: 1.15em;">‖</p>
<p>Need Assistance</p>
</td>
<td style="text-align: right;">25%</td>
</tr>
<tr style="text-align: center;">
<td style="text-align: left; width: 320px;">Recycle Broken Hardware</td>
<td style="text-align: center; color: #5cb85c;">
<p style="font-size: 1.15em;">✓</p>
<p>Completed</p>
</td>
<td style="text-align: right;">100%</td>
</tr>
</tbody>
</table>
<br>
`;
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
},
defaultExtension: 'js',
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.8/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.24/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.64/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const markup = `
<h2>
Hardware Upgrade
</h2>
<br>
<table>
<thead>
<tr>
<th style="text-align: left; width: 320px;">Task Subject</th>
<th style="text-align: center;">Status</th>
<th style="text-align: right;">Progress</th>
</tr>
</thead>
<tbody>
<tr style="text-align: center;">
<td style="text-align: left; width: 320px;">Approve Personal Computer Upgrade Plan</td>
<td style="text-align: center; color: #5cb85c;">
<p style="font-size: 1.15em;">✓</p>
<p>Completed</p>
</td>
<td style="text-align: right;">100%</td>
</tr>
<tr style="text-align: center;">
<td style="text-align: left; width: 320px;">Prepare workspaces</td>
<td style="text-align: center; color: #5cb85c;">
<p style="font-size: 1.15em;">✓</p>
<p>Completed</p>
</td>
<td style="text-align: right;">100%</td>
</tr>
<tr style="text-align: center;">
<td style="text-align: left; width: 320px;">Upgrade Server Hardware</td>
<td style="text-align: center;">
<p style="font-size: 1.15em;">⟳</p>
<p>In Progress</p>
</td>
<td style="text-align: right;">45%</td>
</tr>
<tr style="text-align: center;">
<td style="text-align: left; width: 320px;">Upgrade Personal Computers</td>
<td style="text-align: center; color: #f0ad4e;">
<p style="font-size: 1.15em;">‖</p>
<p>Need Assistance</p>
</td>
<td style="text-align: right;">80%</td>
</tr>
<tr style="text-align: center;">
<td style="text-align: left; width: 320px;">Replace HDD with SSD</td>
<td style="text-align: center;">
<p style="font-size: 1.15em;">⟳</p>
<p>In Progress</p>
</td>
<td style="text-align: right;">80%</td>
</tr>
<tr style="text-align: center;">
<td style="text-align: left; width: 320px;">Purchase a New Server</td>
<td style="text-align: center; color: #d9534f;">
<p style="font-size: 1.15em;">✖</p>
<p>Canceled</p>
</td>
<td style="text-align: right;">15%</td>
</tr>
<tr style="text-align: center;">
<td style="text-align: left; width: 320px;">Purchase Laptops</td>
<td style="text-align: center; color: #5cb85c;">
<p style="font-size: 1.15em;">✓</p>
<p>Completed</p>
</td>
<td style="text-align: right;">100%</td>
</tr>
<tr style="text-align: center;">
<td style="text-align: left; width: 320px;">Prepare a list of necessary devices for testing</td>
<td style="text-align: center; color: #5cb85c;">
<p style="font-size: 1.15em;">✓</p>
<p>Completed</p>
</td>
<td style="text-align: right;">100%</td>
</tr>
<tr style="text-align: center;">
<td style="text-align: left; width: 320px;">Purchase devices for testing</td>
<td style="text-align: center; color: #f0ad4e;">
<p style="font-size: 1.15em;">‖</p>
<p>Need Assistance</p>
</td>
<td style="text-align: right;">25%</td>
</tr>
<tr style="text-align: center;">
<td style="text-align: left; width: 320px;">Recycle Broken Hardware</td>
<td style="text-align: center; color: #5cb85c;">
<p style="font-size: 1.15em;">✓</p>
<p>Completed</p>
</td>
<td style="text-align: right;">100%</td>
</tr>
</tbody>
</table>
<br>
`;
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.demo-container {
height: 950px;
}
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
margin-top: 20px;
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
}

<dx-html-editor height="750px" [value]="valueContent">
<dxo-html-editor-table-context-menu
[enabled]="contextMenuEnabled"
></dxo-html-editor-table-context-menu>
<dxo-html-editor-table-resizing
[enabled]="allowResizing"
></dxo-html-editor-table-resizing>
<dxo-html-editor-toolbar>
<dxi-html-editor-item name="bold"></dxi-html-editor-item>
<dxi-html-editor-item name="color"></dxi-html-editor-item>
<dxi-html-editor-item name="separator"></dxi-html-editor-item>
<dxi-html-editor-item name="alignLeft"></dxi-html-editor-item>
<dxi-html-editor-item name="alignCenter"></dxi-html-editor-item>
<dxi-html-editor-item name="alignRight"></dxi-html-editor-item>
<dxi-html-editor-item name="separator"></dxi-html-editor-item>
<dxi-html-editor-item name="insertTable"></dxi-html-editor-item>
<dxi-html-editor-item name="insertHeaderRow"></dxi-html-editor-item>
<dxi-html-editor-item name="insertRowAbove"></dxi-html-editor-item>
<dxi-html-editor-item name="insertRowBelow"></dxi-html-editor-item>
<dxi-html-editor-item name="separator"></dxi-html-editor-item>
<dxi-html-editor-item name="insertColumnLeft"></dxi-html-editor-item>
<dxi-html-editor-item name="insertColumnRight"></dxi-html-editor-item>
<dxi-html-editor-item name="separator"></dxi-html-editor-item>
<dxi-html-editor-item name="deleteColumn"></dxi-html-editor-item>
<dxi-html-editor-item name="deleteRow"></dxi-html-editor-item>
<dxi-html-editor-item name="deleteTable"></dxi-html-editor-item>
<dxi-html-editor-item name="separator"></dxi-html-editor-item>
<dxi-html-editor-item name="cellProperties"></dxi-html-editor-item>
<dxi-html-editor-item name="tableProperties"></dxi-html-editor-item>
</dxo-html-editor-toolbar>
</dx-html-editor>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<dx-check-box
text="Allow Table Resizing"
[(value)]="allowResizing"
></dx-check-box>
</div>
<div class="option">
<dx-check-box
text="Enable Table Context Menu"
[(value)]="contextMenuEnabled"
></dx-check-box>
</div>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxHtmlEditorModule, DxCheckBoxModule } from 'devextreme-angular';
import { Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
imports: [
DxHtmlEditorModule,
DxCheckBoxModule,
],
})
export class AppComponent {
valueContent: string;
allowResizing = true;
contextMenuEnabled = true;
constructor(service: Service) {
this.valueContent = service.getMarkup();
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep .demo-container {
height: 950px;
}
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
margin-top: 20px;
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
}
import { Injectable } from '@angular/core';
const markup = `
<h2>
Hardware Upgrade
</h2>
<br>
<table>
<thead>
<tr>
<th style="text-align: left; width: 320px;">Task Subject</th>
<th style="text-align: center;">Status</th>
<th style="text-align: right;">Progress</th>
</tr>
</thead>
<tbody>
<tr style="text-align: center;">
<td style="text-align: left; width: 320px;">Approve Personal Computer Upgrade Plan</td>
<td style="text-align: center; color: #5cb85c;">
<p style="font-size: 1.15em;">✓</p>
<p>Completed</p>
</td>
<td style="text-align: right;">100%</td>
</tr>
<tr style="text-align: center;">
<td style="text-align: left; width: 320px;">Prepare workspaces</td>
<td style="text-align: center; color: #5cb85c;">
<p style="font-size: 1.15em;">✓</p>
<p>Completed</p>
</td>
<td style="text-align: right;">100%</td>
</tr>
<tr style="text-align: center;">
<td style="text-align: left; width: 320px;">Upgrade Server Hardware</td>
<td style="text-align: center;">
<p style="font-size: 1.15em;">⟳</p>
<p>In Progress</p>
</td>
<td style="text-align: right;">45%</td>
</tr>
<tr style="text-align: center;">
<td style="text-align: left; width: 320px;">Upgrade Personal Computers</td>
<td style="text-align: center; color: #f0ad4e;">
<p style="font-size: 1.15em;">‖</p>
<p>Need Assistance</p>
</td>
<td style="text-align: right;">80%</td>
</tr>
<tr style="text-align: center;">
<td style="text-align: left; width: 320px;">Replace HDD with SSD</td>
<td style="text-align: center;">
<p style="font-size: 1.15em;">⟳</p>
<p>In Progress</p>
</td>
<td style="text-align: right;">80%</td>
</tr>
<tr style="text-align: center;">
<td style="text-align: left; width: 320px;">Purchase a New Server</td>
<td style="text-align: center; color: #d9534f;">
<p style="font-size: 1.15em;">✖</p>
<p>Canceled</p>
</td>
<td style="text-align: right;">15%</td>
</tr>
<tr style="text-align: center;">
<td style="text-align: left; width: 320px;">Purchase Laptops</td>
<td style="text-align: center; color: #5cb85c;">
<p style="font-size: 1.15em;">✓</p>
<p>Completed</p>
</td>
<td style="text-align: right;">100%</td>
</tr>
<tr style="text-align: center;">
<td style="text-align: left; width: 320px;">Prepare a list of necessary devices for testing</td>
<td style="text-align: center; color: #5cb85c;">
<p style="font-size: 1.15em;">✓</p>
<p>Completed</p>
</td>
<td style="text-align: right;">100%</td>
</tr>
<tr style="text-align: center;">
<td style="text-align: left; width: 320px;">Purchase devices for testing</td>
<td style="text-align: center; color: #f0ad4e;">
<p style="font-size: 1.15em;">‖</p>
<p>Need Assistance</p>
</td>
<td style="text-align: right;">25%</td>
</tr>
<tr style="text-align: center;">
<td style="text-align: left; width: 320px;">Recycle Broken Hardware</td>
<td style="text-align: center; color: #5cb85c;">
<p style="font-size: 1.15em;">✓</p>
<p>Completed</p>
</td>
<td style="text-align: right;">100%</td>
</tr>
</tbody>
</table>
<br>
`;
@Injectable()
export class Service {
getMarkup(): string {
return markup;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'demo-ts-shared': 'project:utils/demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.0.2"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

<template>
<div>
<DxHtmlEditor
:value="markup"
height="750px"
>
<DxTableContextMenu :enabled="contextMenuEnabled"/>
<DxTableResizing :enabled="allowResizing"/>
<DxToolbar>
<DxItem name="bold"/>
<DxItem name="color"/>
<DxItem name="separator"/>
<DxItem name="alignLeft"/>
<DxItem name="alignCenter"/>
<DxItem name="alignRight"/>
<DxItem name="separator"/>
<DxItem name="insertTable"/>
<DxItem name="insertHeaderRow"/>
<DxItem name="insertRowAbove"/>
<DxItem name="insertRowBelow"/>
<DxItem name="separator"/>
<DxItem name="insertColumnLeft"/>
<DxItem name="insertColumnRight"/>
<DxItem name="separator"/>
<DxItem name="deleteColumn"/>
<DxItem name="deleteRow"/>
<DxItem name="deleteTable"/>
<DxItem name="separator"/>
<DxItem name="cellProperties"/>
<DxItem name="tableProperties"/>
</DxToolbar>
</DxHtmlEditor>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<DxCheckBox
v-model:value="allowResizing"
text="Allow Table Resizing"
/>
</div>
<div class="option">
<DxCheckBox
v-model:value="contextMenuEnabled"
text="Enable Table Context Menu"
/>
</div>
</div>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import {
DxHtmlEditor,
DxTableContextMenu,
DxTableResizing,
DxToolbar,
DxItem,
} from 'devextreme-vue/html-editor';
import { DxCheckBox } from 'devextreme-vue/check-box';
import { markup } from './data.ts';
const allowResizing = ref(true);
const contextMenuEnabled = ref(true);
</script>
<style>
.demo-container {
height: 950px;
}
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
margin-top: 20px;
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.32/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'project:utils/demo-vue-loader.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'demo-ts-shared': 'project:utils/demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
export const markup = `
<h2>
Hardware Upgrade
</h2>
<br>
<table>
<thead>
<tr>
<th style="text-align: left; width: 320px;">Task Subject</th>
<th style="text-align: center;">Status</th>
<th style="text-align: right;">Progress</th>
</tr>
</thead>
<tbody>
<tr style="text-align: center;">
<td style="text-align: left; width: 320px;">Approve Personal Computer Upgrade Plan</td>
<td style="text-align: center; color: #5cb85c;">
<p style="font-size: 1.15em;">✓</p>
<p>Completed</p>
</td>
<td style="text-align: right;">100%</td>
</tr>
<tr style="text-align: center;">
<td style="text-align: left; width: 320px;">Prepare workspaces</td>
<td style="text-align: center; color: #5cb85c;">
<p style="font-size: 1.15em;">✓</p>
<p>Completed</p>
</td>
<td style="text-align: right;">100%</td>
</tr>
<tr style="text-align: center;">
<td style="text-align: left; width: 320px;">Upgrade Server Hardware</td>
<td style="text-align: center;">
<p style="font-size: 1.15em;">⟳</p>
<p>In Progress</p>
</td>
<td style="text-align: right;">45%</td>
</tr>
<tr style="text-align: center;">
<td style="text-align: left; width: 320px;">Upgrade Personal Computers</td>
<td style="text-align: center; color: #f0ad4e;">
<p style="font-size: 1.15em;">‖</p>
<p>Need Assistance</p>
</td>
<td style="text-align: right;">80%</td>
</tr>
<tr style="text-align: center;">
<td style="text-align: left; width: 320px;">Replace HDD with SSD</td>
<td style="text-align: center;">
<p style="font-size: 1.15em;">⟳</p>
<p>In Progress</p>
</td>
<td style="text-align: right;">80%</td>
</tr>
<tr style="text-align: center;">
<td style="text-align: left; width: 320px;">Purchase a New Server</td>
<td style="text-align: center; color: #d9534f;">
<p style="font-size: 1.15em;">✖</p>
<p>Canceled</p>
</td>
<td style="text-align: right;">15%</td>
</tr>
<tr style="text-align: center;">
<td style="text-align: left; width: 320px;">Purchase Laptops</td>
<td style="text-align: center; color: #5cb85c;">
<p style="font-size: 1.15em;">✓</p>
<p>Completed</p>
</td>
<td style="text-align: right;">100%</td>
</tr>
<tr style="text-align: center;">
<td style="text-align: left; width: 320px;">Prepare a list of necessary devices for testing</td>
<td style="text-align: center; color: #5cb85c;">
<p style="font-size: 1.15em;">✓</p>
<p>Completed</p>
</td>
<td style="text-align: right;">100%</td>
</tr>
<tr style="text-align: center;">
<td style="text-align: left; width: 320px;">Purchase devices for testing</td>
<td style="text-align: center; color: #f0ad4e;">
<p style="font-size: 1.15em;">‖</p>
<p>Need Assistance</p>
</td>
<td style="text-align: right;">25%</td>
</tr>
<tr style="text-align: center;">
<td style="text-align: left; width: 320px;">Recycle Broken Hardware</td>
<td style="text-align: center; color: #5cb85c;">
<p style="font-size: 1.15em;">✓</p>
<p>Completed</p>
</td>
<td style="text-align: right;">100%</td>
</tr>
</tbody>
</table>
<br>
`;
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>